#ifndef COMSOMME_H
#define COMSOMME_H

#include "IUnknownImpl.h"
#include "../Commun/Somme_h.h"
#include "Mutex.h"
#include "Autoverrou.h"

// ----------------------------------------------------
// Class COMSomme : implmentation encapsule de ISomme
// (version singleton)
// ----------------------------------------------------
class COMSomme : virtual public IUnknownImpl, virtual public ISomme
{
   Mutex m_Mutex;
   static COMSomme *Instance;
   static Mutex OntoVerrou;
public:
   static void NouveauClient()
   {
      Autoverrou a(OntoVerrou);
      if (GetInstance ())
         GetInstance ()->AddRef ();
      else
         Instance = new COMSomme;
   }
   static COMSomme *GetInstance ()
   {
      return Instance;
   }
   // Pour IUnknown
   unsigned long __stdcall AddRef ()
   {
      Autoverrou a(m_Mutex);
      return IUnknownImpl::AddRef ();
   }
   unsigned long __stdcall Release ()
   {
      Autoverrou a(m_Mutex);
      return IUnknownImpl::Release ();
   }
   HRESULT __stdcall QueryInterface (REFIID riid, void **ppv);
   // Pour ISomme
   HRESULT __stdcall Somme (int x, int y, int *Resultat);
   // constructeur et destructeur 
   COMSomme () : IUnknownImpl (), ISomme ()
   {
      Instance = this;
   }
   ~COMSomme ()
   {
      Autoverrou a(OntoVerrou);
      Instance = 0;
   }
};
#endif // !defined COMSOMME_H
