#ifndef STD_CREATE_INSTANCE_H
#define STD_CREATE_INSTANCE_H
#include <unknwn.h>
template <class T>
HRESULT StdCreateInstance (IUnknown *pUnkOuter,
                           REFIID riid,
                           void **ppv)
{
   if (pUnkOuter != 0)
   {
      return CLASS_E_NOAGGREGATION;
   }
   T *p = new T();
   if (p == 0)
      return E_OUTOFMEMORY;
   HRESULT hr = p->QueryInterface (riid, ppv);
   p->Release ();
   return hr;
}

template <class T>
HRESULT StdSingletonCreateInstance (IUnknown *pUnkOuter,
                                    REFIID riid,
                                    void **ppv)
{
   if (pUnkOuter != 0) // rejet de tout pUnkOuter non nul
      return CLASS_E_NOAGGREGATION;
   // Instanciation ou ajout de rfrence
   T::NouveauClient ();
   // Ici, le singleton a assurment au moins un client
   if (T::GetInstance () == 0) // mmoire insuffisante?
      return E_OUTOFMEMORY;
   // Interrogation de l'identit du composant
   HRESULT hr = T::GetInstance ()->QueryInterface (riid, ppv);
   T::GetInstance ()->Release ();
   return hr;
}
#endif
